/// <reference types="typed-graphql" />
/// <reference types="chai" />
/// <reference types="node" />
import { Document, FragmentDefinition } from 'graphql';
import { OperationResultReducer, MutationBehavior, MutationQueryReducersMap } from '../data/mutationResults';
export interface ModifiableWatchQueryOptions {
    variables?: {
        [key: string]: any;
    };
    forceFetch?: boolean;
    returnPartialData?: boolean;
    noFetch?: boolean;
    pollInterval?: number;
    notifyOnNetworkStatusChange?: boolean;
    reducer?: OperationResultReducer;
}
export interface WatchQueryOptions extends ModifiableWatchQueryOptions {
    query: Document;
}
export interface DeprecatedWatchQueryOptions extends ModifiableWatchQueryOptions {
    query: Document;
    fragments?: FragmentDefinition[];
}
export interface FetchMoreQueryOptions {
    query?: Document;
    variables?: {
        [key: string]: any;
    };
    fragments?: FragmentDefinition[];
}
export declare type SubscribeToMoreOptions = {
    document: Document;
    variables?: {
        [key: string]: any;
    };
    updateQuery: (previousQueryResult: Object, options: {
        subscriptionData: {
            data: any;
        };
        variables: {
            [key: string]: any;
        };
    }) => Object;
    onError?: (error: Error) => void;
};
export interface DeprecatedSubscriptionOptions {
    query: Document;
    variables?: {
        [key: string]: any;
    };
    fragments?: FragmentDefinition[];
}
export interface MutationOptions {
    mutation: Document;
    variables?: Object;
    resultBehaviors?: MutationBehavior[];
    fragments?: FragmentDefinition[];
    optimisticResponse?: Object;
    updateQueries?: MutationQueryReducersMap;
    refetchQueries?: string[];
}
